"""
Description of the Caesar Shift Catalogue
An anonymous client wants a program which will create a custom Caesar Shift Code. <br>
The client wants some form of GUI, into which she can input the number of the shift. <br>
She also wants to be able to input a string of up to 10 characters (maybe more at a later time) and have it encoded. <br>
The client also wants a txt file with all 26 letters of the alphabet and their code, for the final chosen shift key. <br>
Remember: <br>
Caesar Shift 1 'a' -> 'b' <br>
Caesar Shift 2 'a' -> 'c' <br>
and so on. <br>
The wraparound applies so that for Caesar Shift 2 'z' -> 'b' <br>
"""

#import all the Tkinter modules
from tkinter import *

# --------------------------------------------------------------------
# click() is a function (or definition). It is only called once below.
def click() :
    
    
    #main program to Caesar Shift the user's string
    #set a default in case the user enters dodgy data
    userString = " "
    encryptedString = "?"
    userKey = 0

    #ask for the string of characters
    userString = stringEntry.get()
    userKey = int(keyEntry.get())

    #only work on the user input if the string is text and a valid userkey
    if userString.isalpha() and (userKey > 0 and userKey < 26):

        #loop through each letter in the userString;
        encryptedString = ""
        for userLetter in userString :
            
            #convert letter to uft8 and add on the cipher value             
            utf8Value = ord(userLetter)
            cipherValue = utf8Value + userKey

            #lower case letter first  .. is there a wraparound needed?
            if userLetter.islower() :
                if cipherValue > ord('z') :
                    cipherValue = cipherValue - 26
            elif cipherValue > ord('Z'):
            #upper case letter .... check for wraparound
                cipherValue = cipherValue - 26

            #store the encrypted letter in the encrypted string
            encryptedString += chr(cipherValue)

    output.delete(0.0, END)
    #print("\nYour letter", userLetter)
    #print("Your key", userKey)
    #print("Your Caesar code", chr(cipherValue))
    
    output.insert(END,encryptedString)

    #Create the catalogue of code in a txt file using a dictionary
    #each Key in the dictionary is indexed from an alphabet list of letters and each Value is the ciphered letter 
    cipherRecord = {}
    if (userKey < 0 or userKey > 25) :
        userKey = 0
        
    alphabetIndex = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']
    for letter in alphabetIndex :
        cipherValue = ord(letter) + userKey
        if cipherValue > ord('z') :
            cipherValue -= 26
        cipherRecord[letter] = chr(cipherValue)

    caesarFile = open("Caesar Shift Catalogue.txt", "w")
    caesarFile.write("Caesar Shift Key : " + str(userKey) + "\n")
    for letter, cipherLetter in cipherRecord.items() :
        caesarFile.write(letter + " ->>> " + cipherLetter + "\n")
    caesarFile.close()
        
        
        
#-----------------------------------------------------------------------        


# initialise the Tkinter window
win = Tk()
win.title("UI - Let Caesar Encrypt your Letter")
win.maxsize(width=600, height=200)
win.configure(background = "black")


#3 rows - INPUT the letter firstly....
Label(win, text = "Input your String", bg="light green", width = 30, height = 2).grid(row = 1,column=0, sticky=W)
#Entry displays a box; you can then get() the text written into the box.
stringEntry = Entry(win, bg="white")
stringEntry.grid(row=1, column=1, sticky=W)

# .......INPUT the KEY secondly....
Label(win, text = "Input your Key (1-25)", bg="light green", width = 30, height = 2).grid(row = 2,column=0, sticky=W)
#Entry displays a box; you can then get() the text written into the box.
keyEntry = Entry(win, bg="white")
keyEntry.grid(row=2, column=1, sticky=W)


# .. and OUTPUT.
#The colours are written here in hexadecimal, just to show a common alternative to a string description.
#The format is #RRGGBB.
Label(win, text="The Encrypted String", bg = "#00ffff", width=30, height=2).grid(row = 3,column=0, sticky=W)
output = Text(win, width=15, height=1, wrap=WORD, background="#ffffff")
output.grid(row = 3, column=1, sticky=W)
Label(win,width=40, bg="#000000").grid(row= 4, column=0, sticky=W)



button = Button(win, text="Submit the string", command=click).grid(row=5,column=0, sticky=W)
qbutton = Button(win, text="QUIT", command=win.destroy).grid(row=5, column=2, sticky=W)

win.mainloop()      # infinite loop to capture events
